OSDN Git Service

Get size_t typedef using gcc, not cc
[pf3gnuchains/gcc-fork.git] / gcc / fixincludes
1 #! /bin/sh
2 # Install modified versions of certain ANSI-incompatible system header files
3 # which are fixed to work correctly with ANSI C
4 # and placed in a directory that GNU C will search.
5
6 # See README-fixinc for more information.
7
8 # Command to run gcc.
9 GCCCMD=${4-${GCCCMD-gcc}}
10
11 # Directory where gcc sources (and sometimes special include files) live.
12 # fixincludes doesn't use this, but fixinc.svr4 does, and I want to make
13 # sure somebody doesn't try to use arg3 for something incompatible. -- gumby
14 SRCDIR=${3-${SRCDIR-.}}
15
16 # Directory containing the original header files.
17 # (This was named INCLUDES, but that conflicts with a name in Makefile.in.)
18 INPUT=${2-${INPUT-/usr/include}}
19
20 # Directory in which to store the results.
21 LIB=${1?"fixincludes: output directory not specified"}
22
23 # Define PWDCMD as a command to use to get the working dir
24 # in the form that we want.
25 PWDCMD=pwd
26 case "`pwd`" in
27 //*)
28         # On an Apollo, discard everything before `/usr'.
29         PWDCMD="eval pwd | sed -e 's,.*/usr/,/usr/,'"
30         ;;
31 esac
32
33 # Original directory.
34 ORIGDIR=`${PWDCMD}`
35
36 # Make sure it exists.
37 if [ ! -d $LIB ]; then
38   mkdir $LIB || exit 1
39 fi
40
41 # Make LIB absolute only if needed to avoid problems with the amd.
42 case $LIB in
43 /*)
44         ;;
45 *)
46         cd $LIB; LIB=`${PWDCMD}`
47         ;;
48 esac
49
50 # Make SRCDIR absolute only if needed to avoid problems with the amd.
51 cd $ORIGDIR
52 case $SRCDIR in
53 /*)
54         ;;
55 *)
56         cd $SRCDIR; SRCDIR=`${PWDCMD}`
57         ;;
58 esac
59
60 # Fail if no arg to specify a directory for the output.
61 if [ x$1 = x ]
62 then echo fixincludes: no output directory specified
63 exit 1
64 fi
65
66 echo Building fixed headers in ${LIB}
67
68 # Determine whether this system has symbolic links.
69 if ln -s X $LIB/ShouldNotExist 2>/dev/null; then
70   rm -f $LIB/ShouldNotExist
71   LINKS=true
72 elif ln -s X /tmp/ShouldNotExist 2>/dev/null; then
73   rm -f /tmp/ShouldNotExist
74   LINKS=true
75 else
76   LINKS=false
77 fi
78
79 echo Finding directories and links to directories
80 cd ${INPUT}
81 # Find all directories and all symlinks that point to directories.
82 # Put the list in $files.
83 # Each time we find a symlink, add it to newdirs
84 # so that we do another find within the dir the link points to.
85 # Note that $files may have duplicates in it;
86 # later parts of this file are supposed to ignore them.
87 dirs="."
88 levels=2
89 while [ -n "$dirs" ] && [ $levels -gt 0 ]
90 do
91     levels=`expr $levels - 1`
92     newdirs=
93     for d in $dirs
94     do
95         echo " Searching $INPUT/$d"
96         if [ "$d" != . ]
97         then
98             d=$d/.
99         fi
100
101         # Find all directories under $d, relative to $d, excluding $d itself.
102         files="$files `find $d -type d -print | \
103                        sed -e '/\/\.$/d' -e '/^\.$/d'`"
104         # Find all links to directories.
105         # Using `-exec test -d' in find fails on some systems,
106         # and trying to run test via sh fails on others,
107         # so this is the simplest alternative left.
108         # First find all the links, then test each one.
109         theselinks=
110         $LINKS && \
111           theselinks=`find $d -type l -print`
112         for d1 in $theselinks --dummy--
113         do
114             # If the link points to a directory,
115             # add that dir to $newdirs
116             if [ -d $d1 ]
117             then
118                 newdirs="$newdirs $d1"
119             fi
120         done
121     done
122
123     files="$files $newdirs"
124     dirs="$newdirs"
125 done
126
127 dirs=
128 echo "All directories (including links to directories):"
129 echo $files
130
131 for file in $files; do
132   rm -rf $LIB/$file
133   if [ ! -d $LIB/$file ]
134   then mkdir $LIB/$file
135   fi
136 done
137 mkdir $LIB/root
138
139 # treetops gets an alternating list
140 # of old directories to copy
141 # and the new directories to copy to.
142 treetops="${INPUT} ${LIB}"
143
144 if $LINKS; then
145   echo 'Making symbolic directory links'
146   for file in $files; do
147     dest=`ls -ld $file | sed -n 's/.*-> //p'`
148     if [ "$dest" ]; then    
149       cwd=`${PWDCMD}`
150       # In case $dest is relative, get to $file's dir first.
151       cd ${INPUT}
152       cd `echo ./$file | sed -n 's&[^/]*$&&p'`
153       # Check that the target directory exists.
154       # Redirections changed to avoid bug in sh on Ultrix.
155       (cd $dest) > /dev/null 2>&1
156       if [ $? = 0 ]; then
157         cd $dest
158         # X gets the dir that the link actually leads to.
159         x=`${PWDCMD}`
160         # If a link points to ., make a similar link to .
161         if [ $x = $INPUT ]; then
162           echo $file '->' . ': Making link'
163           rm -fr ${LIB}/$file > /dev/null 2>&1
164           ln -s . ${LIB}/$file > /dev/null 2>&1
165         # If link leads back into ${INPUT},
166         # make a similar link here.
167         elif expr $x : "${INPUT}/.*" > /dev/null; then
168           # Y gets the actual target dir name, relative to ${INPUT}.
169           y=`echo $x | sed -n "s&${INPUT}/&&p"`
170           # DOTS is the relative path from ${LIB}/$file's dir back to ${LIB}.
171           dots=`echo "$file" |
172                 sed -e 's@^./@@' -e 's@[^/][^/]*@..@g' -e 's@..$@@'`
173           echo $file '->' $dots$y ': Making link'
174           rm -fr ${LIB}/$file > /dev/null 2>&1
175           ln -s $dots$y ${LIB}/$file > /dev/null 2>&1
176         else
177           # If the link is to a dir $target outside ${INPUT},
178           # repoint the link at ${INPUT}/root$target
179           # and process $target into ${INPUT}/root$target
180           # treat this directory as if it actually contained the files.
181           echo $file '->' root$x ': Making link'
182           if [ -d $LIB/root$x ]
183           then true
184           else
185             dirname=root$x/
186             dirmade=.
187             cd $LIB
188             while [ x$dirname != x ]; do
189               component=`echo $dirname | sed -e 's|/.*$||'`
190               mkdir $component >/dev/null 2>&1
191               cd $component
192               dirmade=$dirmade/$component
193               dirname=`echo $dirname | sed -e 's|[^/]*/||'`
194             done
195           fi
196           # Duplicate directory structure created in ${LIB}/$file in new
197           # root area.
198           for file2 in $files; do
199             case $file2 in
200               $file/./*)
201                 dupdir=${LIB}/root$x/`echo $file2 | sed -n "s|^${file}/||p"`
202                 echo "Duplicating ${file}'s ${dupdir}"
203                 if [ -d ${dupdir} ]
204                 then true
205                 else
206                   mkdir ${dupdir}
207                 fi
208                 ;;
209               *)
210                 ;;
211             esac
212           done
213           # DOTS is the relative path from ${LIB}/$file's dir back to ${LIB}.
214           dots=`echo "$file" |
215                 sed -e 's@^./@@' -e 's@[^/][^/]*@..@g' -e 's@..$@@'`
216           rm -fr ${LIB}/$file > /dev/null 2>&1
217           ln -s ${dots}root$x ${LIB}/$file > /dev/null 2>&1
218           treetops="$treetops $x ${LIB}/root$x"
219         fi
220       fi
221       cd $cwd
222     fi
223   done
224 fi
225
226 set x $treetops
227 shift
228 while [ $# != 0 ]; do
229   # $1 is an old directory to copy, and $2 is the new directory to copy to.
230   cd ${INPUT}
231   cd $1
232 # The same dir can appear more than once in treetops.
233 # There's no need to scan it more than once.
234   if [ -f $2/DONE ]
235   then
236     files=
237   else
238     touch $2/DONE
239     echo Fixing directory $1 into $2
240 # Check .h files which are symlinks as well as those which are files.
241 # A link to a header file will not be processed by anything but this.
242     if $LINKS; then
243       files=`find . -name '*.h' \( -type f -o -type l \) -print`
244     else
245       files=`find . -name '*.h' -type f -print`
246     fi
247     echo Checking header files
248   fi
249 # Note that BSD43_* are used on recent MIPS systems.
250   for file in $files; do
251 # This call to egrep is essential, since checking a file with egrep
252 # is much faster than actually trying to fix it.
253 # It is also essential that most files *not* match!
254 # Thus, matching every #endif is unacceptable.
255 # But the argument to egrep must be kept small, or many versions of egrep
256 # won't be able to handle it.
257 #
258 # We use the pattern [!-.0-~] instead of [^/    ] to match a noncomment
259 # following #else or #endif because some buggy egreps think [^/] matches
260 # newline, and they thus think `#else ' matches `#e[ndiflse]*[  ]+[^/   ]'.
261 #
262 # We use the pattern [^a-zA-Z0-9_][_a-ce-km-z][a-z0-9] to match an identifier
263 # following #if or #elif that is not surrounded by __.  The `a-ce-km-z'
264 # in this pattern lacks `d' and `l'; this means we don't worry about
265 # identifiers starting with `d' or `l'.  This is OK, since none of the
266 # identifiers below start with `d' or `l'.  It also greatly improves
267 # performance, since many files contain lines of the form `#if ... defined ...'
268 # or `#if lint'.
269     if egrep '//|[      _]_IO|CTRL|^#define.NULL|^#e[nl][ds][ief]*[     ]+[!-.0-~]|^#[el]*if.*[^a-zA-Z0-9_][_a-ce-km-z][a-z0-9]' $file >/dev/null; then
270       if [ -r $file ]; then
271         cp $file $2/$file >/dev/null 2>&1       \
272         || echo "Can't copy $file"
273         chmod +w $2/$file
274         chmod a+r $2/$file
275         # Here is how the sed commands in braces work.
276         # (It doesn't work to put the comments inside the sed commands.)
277                 # Surround each word with spaces, to simplify matching below.
278                 # ANSIfy each pre-ANSI machine-dependent symbol
279                 # by surrounding it with __ __.
280                 # Remove the spaces that we inserted around each word.
281         sed -e '
282                                    :loop
283           /\\$/                 N
284           /\\$/                 b loop
285           s%^\([        ]*#[    ]*else\)[       ]*/[^*].*%\1%
286           s%^\([        ]*#[    ]*else\)[       ]*[^/   ].*%\1%
287           s%^\([        ]*#[    ]*endif\)[      ]*/[^*].*%\1%
288           s%^\([        ]*#[    ]*endif\)[      ]*\*[^/].*%\1%
289           s%^\([        ]*#[    ]*endif\)[      ]*[^/*  ].*%\1%
290           /\/\/[^*]/                    s|//\(.*\)$|/*\1*/|
291           /[    ]_IO[A-Z]*[     ]*(/    s/\(_IO[A-Z]*[  ]*(\)\(.\),/\1'\''\2'\'',/
292           /[    ]BSD43__IO[A-Z]*[       ]*(/    s/(\(.\),/('\''\1'\'',/
293           /#define._IO/                 s/'\''\([cgx]\)'\''/\1/g
294           /#define.BSD43__IO/           s/'\''\([cgx]\)'\''/\1/g
295           /[^A-Z0-9_]CTRL[      ]*(/            s/\([^'\'']\))/'\''\1'\'')/
296           /[^A-Z0-9]_CTRL[      ]*(/            s/\([^'\'']\))/'\''\1'\'')/
297           /#define[     ]*[     ]CTRL/          s/'\''\([cgx]\)'\''/\1/g
298           /#define[     ]*[     ]_CTRL/         s/'\''\([cgx]\)'\''/\1/g
299           /#define.BSD43_CTRL/          s/'\''\([cgx]\)'\''/\1/g
300           /#[el]*if/{
301                 s/[a-zA-Z0-9_][a-zA-Z0-9_]*/ & /g
302
303                 s/ bsd4\([0-9]\) / __bsd4\1__ /g
304                 s/ _*i386 / __i386__ /g
305                 s/ is68k / __is68k__ /g
306                 s/ m68k / __m68k__ /g
307                 s/ mc680\([0-9]\)0 / __mc680\10__ /g
308                 s/ news\([0-9]*\) / __news\1__ /g
309                 s/ ns32000 / __ns32000__ /g
310                 s/ pyr / __pyr__ /g
311                 s/ sony_news / __sony_news__ /g
312                 s/ sparc / __sparc__ /g
313                 s/ sun\([a-z0-9]*\) / __sun\1__ /g
314                 s/ unix / __unix__ /g
315                 s/ vax / __vax__ /g
316
317                 s/ \([a-zA-Z0-9_][a-zA-Z0-9_]*\) /\1/g
318           }
319           /^#define.NULL[       ]/      i\
320                 #undef NULL
321         ' $2/$file > $2/$file.
322         mv $2/$file. $2/$file
323         if cmp $file $2/$file >/dev/null 2>&1; then
324            rm $2/$file
325         else
326            echo Fixed $file
327         fi
328       fi
329     fi
330   done
331   shift; shift
332 done
333
334 cd ${INPUT}
335
336 # Install the proper definition of size_t in header files that it comes from.
337 for file in sys/types.h stdlib.h sys/stdtypes.h; do
338   if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
339     cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
340     chmod +w ${LIB}/$file 2>/dev/null
341     chmod a+r ${LIB}/$file 2>/dev/null
342   fi
343
344   if [ -r ${LIB}/$file ]; then
345     echo Fixing $file comment
346     # Get the definition of __SIZE_TYPE__, if any.
347     # (This file must be called something.c).
348     echo "__SIZE_TYPE__" > ${LIB}/types.c
349     foo=`${GCCCMD} -E -P ${LIB}/types.c`
350     rm -f ${LIB}/types.c
351     # Default to our preferred type.
352     if [ "$foo" = __SIZE_TYPE__ ]; then foo="unsigned long int"; fi
353     sed -e "s/typedef[  a-z_]*[         ]size_t/typedef $foo size_t/" ${LIB}/$file > ${LIB}/${file}.sed
354     rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
355     if cmp $file ${LIB}/$file >/dev/null 2>&1; then
356       rm ${LIB}/$file
357     fi
358   fi
359 done
360
361 # Fix one other error in this file: a mismatched quote not inside a C comment.
362 file=sundev/vuid_event.h
363 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
364   mkdir ${LIB}/sundev 2>/dev/null
365   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
366   chmod +w ${LIB}/$file 2>/dev/null
367   chmod a+r ${LIB}/$file 2>/dev/null
368 fi
369
370 if [ -r ${LIB}/$file ]; then
371   echo Fixing $file comment
372   sed -e "s/doesn't/does not/" ${LIB}/$file > ${LIB}/${file}.sed
373   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
374   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
375     rm ${LIB}/$file
376   fi
377 fi
378
379 # Fix these Sun OS files to avoid an invalid identifier in an #ifdef.
380 file=sunwindow/win_cursor.h
381 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
382 #  mkdir ${LIB}/sunwindow 2>/dev/null
383   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
384   chmod +w ${LIB}/$file 2>/dev/null
385 fi
386 if [ -r ${LIB}/$file ]; then
387   echo Fixing $file
388   sed -e "s/ecd.cursor/ecd_cursor/" ${LIB}/$file > ${LIB}/${file}.sed
389   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
390   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
391     rm ${LIB}/$file
392   fi
393 fi
394 file=sunwindow/win_lock.h
395 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
396 #  mkdir ${LIB}/sunwindow 2>/dev/null
397   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
398   chmod +w ${LIB}/$file 2>/dev/null
399 fi
400 if [ -r ${LIB}/$file ]; then
401   echo Fixing $file
402   sed -e "s/ecd.cursor/ecd_cursor/" ${LIB}/$file > ${LIB}/${file}.sed
403   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
404   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
405     rm ${LIB}/$file
406   fi
407 fi
408
409 # Fix this Sun file to avoid interfering with stddef.h.
410 file=sys/stdtypes.h
411 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
412   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
413   chmod +w ${LIB}/$file 2>/dev/null
414   chmod a+r ${LIB}/$file 2>/dev/null
415 fi
416
417 if [ -r ${LIB}/$file ]; then
418   echo Fixing $file
419 sed -e '/[       ]size_t.*;/i\
420 #ifndef _GCC_SIZE_T\
421 #define _GCC_SIZE_T' \
422     -e '/[       ]size_t.*;/a\
423 #endif' \
424     -e '/[       ]ptrdiff_t.*;/i\
425 #ifndef _GCC_PTRDIFF_T\
426 #define _GCC_PTRDIFF_T' \
427     -e '/[       ]ptrdiff_t.*;/a\
428 #endif' \
429     -e '/[       ]wchar_t.*;/i\
430 #ifndef _GCC_WCHAR_T\
431 #define _GCC_WCHAR_T' \
432     -e '/[       ]wchar_t.*;/a\
433 #endif' ${LIB}/$file > ${LIB}/${file}.sed
434   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
435   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
436     rm ${LIB}/$file
437   fi
438 fi
439
440 # Fix this file to avoid interfering with stddef.h, but don't mistakenly
441 # match e.g. ssize_t present in AIX for the ps/2.
442 file=sys/types.h
443 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
444   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
445   chmod +w ${LIB}/$file 2>/dev/null
446   chmod a+r ${LIB}/$file 2>/dev/null
447 fi
448
449 if [ -r ${LIB}/$file ]; then
450   echo Fixing $file
451 sed -e '/[      ]size_t.*;/i\
452 #ifndef _GCC_SIZE_T\
453 #define _GCC_SIZE_T' \
454     -e '/[      ]size_t.*;/a\
455 #endif' ${LIB}/$file > ${LIB}/${file}.sed
456   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
457   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
458     rm ${LIB}/$file
459   fi
460 fi
461
462 # Fix an error in this file: the #if says _cplusplus, not the double
463 # underscore __cplusplus that it should be
464 file=tinfo.h
465 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
466   mkdir ${LIB}/rpcsvc 2>/dev/null
467   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
468   chmod +w ${LIB}/$file 2>/dev/null
469   chmod a+r ${LIB}/$file 2>/dev/null
470 fi
471
472 if [ -r ${LIB}/$file ]; then
473   echo Fixing $file, __cplusplus macro
474   sed -e 's/[   ]_cplusplus/ __cplusplus/' ${LIB}/$file > ${LIB}/${file}.sed
475   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
476   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
477     rm ${LIB}/$file
478   fi
479 fi
480
481 # Fix an error in this file: a missing semi-colon at the end of the statsswtch
482 # structure definition.
483 file=rpcsvc/rstat.h
484 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
485   mkdir ${LIB}/rpcsvc 2>/dev/null
486   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
487   chmod +w ${LIB}/$file 2>/dev/null
488   chmod a+r ${LIB}/$file 2>/dev/null
489 fi
490
491 if [ -r ${LIB}/$file ]; then
492   echo Fixing $file, definition of statsswtch
493   sed -e 's/boottime$/boottime;/' ${LIB}/$file > ${LIB}/${file}.sed
494   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
495   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
496     rm ${LIB}/$file
497   fi
498 fi
499
500 # Fix an error in this file: a missing semi-colon at the end of the nodeent
501 # structure definition.
502 file=netdnet/dnetdb.h
503 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
504   mkdir ${LIB}/netdnet 2>/dev/null
505   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
506   chmod +w ${LIB}/$file 2>/dev/null
507   chmod a+r ${LIB}/$file 2>/dev/null
508 fi
509
510 if [ -r ${LIB}/$file ]; then
511   echo Fixing $file, definition of nodeent
512   sed -e 's/char.*na_addr *$/char *na_addr;/' ${LIB}/$file > ${LIB}/${file}.sed
513   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
514   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
515     rm ${LIB}/$file
516   fi
517 fi
518
519 # Check for bad #ifdef line (in Ultrix 4.1)
520 file=sys/file.h
521 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
522   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
523   chmod +w ${LIB}/$file 2>/dev/null
524   chmod a+r ${LIB}/$file 2>/dev/null
525 fi
526
527 if [ -r ${LIB}/$file ]; then
528   echo Fixing $file, bad \#ifdef line
529   sed -e 's/#ifdef KERNEL/#if defined(KERNEL)/' ${LIB}/$file > ${LIB}/${file}.sed
530   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
531   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
532     rm ${LIB}/$file
533   fi
534 fi
535
536 # Check for superfluous `static' (in Ultrix 4.2)
537 file=machine/cpu.h
538 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
539   mkdir ${LIB}/machine 2>/dev/null
540   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
541   chmod +w ${LIB}/$file 2>/dev/null
542   chmod a+r ${LIB}/$file 2>/dev/null
543 fi
544
545 if [ -r ${LIB}/$file ]; then
546   echo Fixing $file, superfluous static
547   sed -e 's/^static struct tlb_pid_state/struct tlb_pid_state/' ${LIB}/$file > ${LIB}/${file}.sed
548   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
549   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
550     rm ${LIB}/$file
551   else
552 # This file has an alternative name, mips/cpu.h.  Fix that name, too.
553     if cmp machine/cpu.h mips/cpu.h > /dev/null 2>&1; then
554       mkdir ${LIB}/mips 2>&-
555       ln ${LIB}/$file ${LIB}/mips/cpu.h 
556     fi
557   fi
558 fi
559
560 # Incorrect sprintf declaration in X11/Xmu.h
561 file=X11/Xmu.h
562 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
563   mkdir ${LIB}/X11 2>/dev/null
564   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
565   chmod +w ${LIB}/$file 2>/dev/null
566   chmod a+r ${LIB}/$file 2>/dev/null
567 fi
568
569 if [ -r ${LIB}/$file ]; then
570   echo Fixing $file sprintf declaration
571   sed -e 's,^extern char \*     sprintf();$,#ifndef __STDC__\
572 extern char *   sprintf();\
573 #endif /* !defined __STDC__ */,' ${LIB}/$file > ${LIB}/${file}.sed
574   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
575   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
576     rm ${LIB}/$file
577   fi
578 fi
579
580 # Incorrect sprintf declaration in X11/Xmu/Xmu.h
581 # (It's not clear whether the right file name is this or X11/Xmu.h.)
582 file=X11/Xmu/Xmu.h
583 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
584   mkdir ${LIB}/X11/Xmu 2>/dev/null
585   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
586   chmod +w ${LIB}/$file 2>/dev/null
587   chmod a+r ${LIB}/$file 2>/dev/null
588 fi
589
590 if [ -r ${LIB}/$file ]; then
591   echo Fixing $file sprintf declaration
592   sed -e 's,^extern char \*     sprintf();$,#ifndef __STDC__\
593 extern char *   sprintf();\
594 #endif /* !defined __STDC__ */,' ${LIB}/$file > ${LIB}/${file}.sed
595   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
596   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
597     rm ${LIB}/$file
598   fi
599 fi
600
601 # Check for missing ';' in struct
602 file=netinet/ip.h
603 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
604   mkdir ${LIB}/netinet 2>/dev/null
605   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
606   chmod +w ${LIB}/$file 2>/dev/null
607   chmod a+r ${LIB}/$file 2>/dev/null
608 fi
609
610 if [ -r ${LIB}/$file ]; then
611   echo Fixing $file
612   sed -e '/^struct/,/^};/s/}$/};/' ${LIB}/$file > ${LIB}/${file}.sed
613   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
614   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
615     rm -f ${LIB}/$file
616   fi
617 fi
618
619 # Fix the CAT macro in SunOS memvar.h.
620 file=pixrect/memvar.h
621 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
622   mkdir ${LIB}/pixrect 2>/dev/null
623   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
624   chmod +w ${LIB}/$file 2>/dev/null
625   chmod a+r ${LIB}/$file 2>/dev/null
626 fi
627
628 if [ -r ${LIB}/$file ]; then
629   echo Fixing $file
630   sed -e '/^#define.CAT(a,b)/ i\
631 #ifdef __STDC__ \
632 #define CAT(a,b) a##b\
633 #else
634 /^#define.CAT(a,b)/ a\
635 #endif
636 ' ${LIB}/$file > ${LIB}/${file}.sed
637   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
638   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
639     rm -f ${LIB}/$file
640   fi
641 fi
642
643 # Check for yet more missing ';' in struct (in SunOS 4.0.x)
644 file=rpcsvc/rusers.h
645 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
646   mkdir ${LIB}/rpcsvc 2>/dev/null
647   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
648   chmod +w ${LIB}/$file 2>/dev/null
649   chmod a+r ${LIB}/$file 2>/dev/null
650 fi
651
652 if [ -r ${LIB}/$file ]; then
653   echo Fixing $file
654   sed -e '/^struct/,/^};/s/_cnt$/_cnt;/' ${LIB}/$file > ${LIB}/${file}.sed
655   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
656   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
657     rm -f ${LIB}/$file
658   fi
659 fi
660
661 # Fix return type of exit and abort in <stdlib.h> on SunOS 4.1.
662 # Also wrap protection around size_t for m88k-sysv3 systems.
663 file=stdlib.h
664 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
665   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
666   chmod +w ${LIB}/$file 2>/dev/null
667   chmod a+r ${LIB}/$file 2>/dev/null
668 fi
669
670 if [ -r ${LIB}/$file ]; then
671   echo Fixing $file
672   sed -e 's/int abort/void      abort/g' \
673   -e 's/int     free/void       free/g' \
674   -e 's/char \* calloc/void \*  calloc/g' \
675   -e 's/char \* malloc/void \*  malloc/g' \
676   -e 's/char \* realloc/void \* realloc/g' \
677   -e 's/int     exit/void       exit/g' \
678   -e '/typedef[         a-zA-Z_]*[      ]size_t[        ]*;/i\
679 #ifndef _GCC_SIZE_T\
680 #define _GCC_SIZE_T' \
681   -e '/typedef[         a-zA-Z_]*[      ]size_t[        ]*;/a\
682 #endif' \
683       ${LIB}/$file > ${LIB}/${file}.sed
684   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
685   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
686     rm -f ${LIB}/$file
687   fi
688 fi
689
690 # Fix return type of free and {c,m,re}alloc in <malloc.h> on SunOS 4.1.
691 file=malloc.h
692 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
693   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
694   chmod +w ${LIB}/$file 2>/dev/null
695   chmod a+r ${LIB}/$file 2>/dev/null
696 fi
697
698 if [ -r ${LIB}/$file ]; then
699   echo Fixing $file
700   sed -e 's/typedef[    ]char \*        malloc_t/typedef void \*        malloc_t/g' \
701   -e 's/int[    ][      ]*free/void     free/g' \
702   ${LIB}/$file > ${LIB}/${file}.sed
703   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
704   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
705     rm -f ${LIB}/$file
706   fi
707 fi
708
709 # Fix bogus #ifdef in <hsfs/hsfs_spec.h> on SunOS 4.1.
710 file=hsfs/hsfs_spec.h
711 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
712   mkdir ${LIB}/hsfs 2>/dev/null
713   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
714   chmod +w ${LIB}/$file 2>/dev/null
715   chmod a+r ${LIB}/$file 2>/dev/null
716 fi
717
718 if [ -r ${LIB}/$file ]; then
719   echo Fixing $file
720   sed -e 's/\#ifdef __i386__ || __vax__/\#if __i386__ || __vax__/g' \
721     ${LIB}/$file > ${LIB}/${file}.
722   rm -f ${LIB}/$file; mv ${LIB}/${file}. ${LIB}/$file
723   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
724     rm -f ${LIB}/$file
725   fi
726 fi
727
728 # Fix bogus #ifdef in <hsfs/hsnode.h> on SunOS 4.1.
729 file=hsfs/hsnode.h
730 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
731   mkdir ${LIB}/hsfs 2>/dev/null
732   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
733   chmod +w ${LIB}/$file 2>/dev/null
734   chmod a+r ${LIB}/$file 2>/dev/null
735 fi
736
737 if [ -r ${LIB}/$file ]; then
738   echo Fixing $file
739   sed -e 's/\#ifdef __i386__ || __sun4c__/\#if __i386__ || __sun4c__/g' \
740     ${LIB}/$file > ${LIB}/${file}.sed
741   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
742   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
743     rm -f ${LIB}/$file
744   fi
745 fi
746
747 # Fix bogus #ifdef in <hsfs/iso_spec.h> on SunOS 4.1.
748 file=hsfs/iso_spec.h
749 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
750   mkdir ${LIB}/hsfs 2>/dev/null
751   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
752   chmod +w ${LIB}/$file 2>/dev/null
753   chmod a+r ${LIB}/$file 2>/dev/null
754 fi
755
756 if [ -r ${LIB}/$file ]; then
757   echo Fixing $file
758   sed -e 's/\#ifdef __i386__ || __vax__/\#if __i386__ || __vax__/g' \
759     ${LIB}/$file > ${LIB}/${file}.sed
760   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
761   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
762     rm -f ${LIB}/$file
763   fi
764 fi
765
766 # Incorrect #include in Sony News-OS 3.2.
767 file=machine/machparam.h
768 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
769   mkdir ${LIB}/machine 2>/dev/null
770   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
771   chmod +w ${LIB}/$file 2>/dev/null
772   chmod a+r ${LIB}/$file 2>/dev/null
773 fi
774
775 if [ -r ${LIB}/$file ]; then
776   echo Fixing $file, incorrect \#include
777   sed -e 's@"../machine/endian.h"@<machine/endian.h>@' \
778     ${LIB}/$file > ${LIB}/${file}.
779   rm -f ${LIB}/$file; mv ${LIB}/${file}. ${LIB}/$file
780   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
781     rm -f ${LIB}/$file
782   fi
783 fi
784
785 # Multiline comment after typedef on IRIX 4.0.1.
786 file=sys/types.h
787 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
788   mkdir ${LIB}/sys 2>/dev/null
789   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
790   chmod +w ${LIB}/$file 2>/dev/null
791   chmod a+r ${LIB}/$file 2>/dev/null
792 fi
793
794 if [ -r ${LIB}/$file ]; then
795   echo Fixing $file, comment in the middle of \#ifdef
796   sed -e 's@type of the result@type of the result */@' \
797     -e 's@of the sizeof@/* of the sizeof@' \
798     ${LIB}/$file > ${LIB}/${file}.sed
799   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
800   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
801     rm -f ${LIB}/$file
802   fi
803 fi
804
805 # Turning // comments into /* */ comments trashes this IRIX 4.0.1
806 # header file, which embeds // comments inside multi-line /* */
807 # comments.  If this looks like the IRIX header file, we refix it by
808 # just throwing away the // comments.
809 file=fam.h
810 if [ -r ${LIB}/$file ]; then
811   if egrep indigo.esd ${LIB}/$file > /dev/null; then
812     echo Fixing $file, overeager sed script
813     rm ${LIB}/$file
814     sed -e 's|//.*$||g' $file > ${LIB}/$file
815     chmod +w ${LIB}/$file 2>/dev/null
816     chmod a+r ${LIB}/$file 2>/dev/null
817   fi
818 fi
819
820 # Another IRIX 4.0.1 header file contains the string "//"
821 file=elf_abi.h
822 if [ -r ${LIB}/$file ]; then
823   echo Fixing $file, overeager sed script
824   sed -e 's|"/\*"\*/|"//"|' ${LIB}/$file > ${LIB}/${file}.sed
825   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
826   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
827     rm -f ${LIB}/$file
828   fi
829 fi
830
831 # Fix non-ANSI memcpy declaration that conflicts with gcc's builtin
832 # declaration on Sun OS 4.x.  We must only fix this on Sun OS 4.x, because
833 # many other systems have similar text but correct versions of the file.
834 # To ensure only Sun's is fixed, we grep for a likely unique string.
835 file=memory.h
836 if [ -r $file ] && egrep '/\*   @\(#\)memory\.h 1\.[2-4] 8./../.. SMI; from S5R2 1\.2   \*/' $file > /dev/null; then
837   if [ ! -r ${LIB}/$file ]; then
838     cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
839     chmod +w ${LIB}/$file 2>/dev/null
840     chmod a+r ${LIB}/$file 2>/dev/null
841   fi
842   if [ -r ${LIB}/$file ]; then
843     echo Replacing $file
844     cat > ${LIB}/$file << EOF
845 /* This file was generated by fixincludes */
846 #ifndef __memory_h__
847 #define __memory_h__
848
849 #ifdef __STDC__
850 extern void *memccpy();
851 extern void *memchr();
852 extern void *memcpy();
853 extern void *memset();
854 #else
855 extern char *memccpy();
856 extern char *memchr();
857 extern char *memcpy();
858 extern char *memset();
859 #endif /* __STDC__ */
860
861 extern int memcmp();
862
863 #endif /* __memory_h__ */
864 EOF
865   fi
866 fi
867
868 # parameters not const on DECstation Ultrix V4.0.
869 file=stdio.h
870 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
871   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
872   chmod +w ${LIB}/$file 2>/dev/null
873   chmod a+r ${LIB}/$file 2>/dev/null
874 fi
875
876 if [ -r ${LIB}/$file ]; then
877   echo Fixing $file, non-const arg
878   sed -e 's@perror( char \*__s );@perror( const char *__s );@' \
879       -e 's@fputs( char \*__s,@fputs( const char *__s,@' \
880       -e 's@fopen( char \*__filename, char \*__type );@fopen( const char *__filename, const char *__type );@' \
881       -e 's@fwrite( void \*__ptr,@fwrite( const void *__ptr,@' \
882       -e 's@fscanf( FILE \*__stream, char \*__format,@fscanf( FILE *__stream, const char *__format,@' \
883       -e 's@scanf( char \*__format,@scanf( const char *__format,@' \
884       -e 's@sscanf( char \*__s, char \*__format,@sscanf( const char *__s, const char *__format,@' \
885     ${LIB}/$file > ${LIB}/${file}.sed
886   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
887   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
888     rm -f ${LIB}/$file
889   fi
890 fi
891
892 # parameters conflict with C++ new on rs/6000 
893 for file in stdio.h unistd.h ; do
894   if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
895     cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
896     chmod +w ${LIB}/$file 2>/dev/null
897   fi
898
899   if [ -r ${LIB}/$file ]; then
900     echo Fixing $file, parameter name conflicts
901     sed -e 's@rename(const char \*old, const char \*new)@rename(const char *_old, const char *_new)@' \
902       ${LIB}/$file > ${LIB}/${file}.sed
903     rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
904     if cmp $file ${LIB}/$file >/dev/null 2>&1; then
905       rm -f ${LIB}/$file
906     fi
907   fi
908 done
909
910 # function class(double x) conflicts with C++ keyword on rs/6000 
911 file=math.h
912 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
913   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
914   chmod +w ${LIB}/$file 2>/dev/null
915   chmod a+r ${LIB}/$file 2>/dev/null
916 fi
917
918 if [ -r ${LIB}/$file ]; then
919   if grep 'class[(]' ${LIB}/$file >/dev/null; then
920     echo Fixing $file
921     sed -e '/class[(]/i\
922 #ifndef __cplusplus' \
923         -e '/class[(]/a\
924 #endif' ${LIB}/$file > ${LIB}/${file}.sed
925     rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
926     if cmp $file ${LIB}/$file >/dev/null 2>&1; then
927       rm ${LIB}/$file
928     fi
929   fi
930 fi
931
932 # NeXT defines 'int wait(union wait*)', which conflicts with Posix.1.
933 file=sys/wait.h
934 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
935   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
936   chmod +w ${LIB}/$file 2>/dev/null
937 fi
938
939 if [ -r ${LIB}/$file ] \
940   && grep 'wait[(]union wait' ${LIB}/$file >/dev/null; then
941   echo Fixing $file, bad wait formal
942   sed -e 's@wait(union wait@wait(void@' ${LIB}/$file > ${LIB}/${file}.sed
943   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
944   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
945     rm -f ${LIB}/$file
946   fi
947 fi
948
949 # Don't use or define the name va_list in stdio.h.
950 # This is for ANSI and also to interoperate properly with gvarargs.h.
951 file=stdio.h
952 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
953   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
954   chmod +w ${LIB}/$file 2>/dev/null
955   chmod a+r ${LIB}/$file 2>/dev/null
956 fi
957
958 if [ -r ${LIB}/$file ]; then
959   echo Fixing $file, use of va_list
960   # Arrange for stdio.h to use stdarg.h to define __gnuc_va_list
961   (echo "#define __need___va_list"
962    echo "#include <stdarg.h>") > ${LIB}/${file}.sed
963   # Use __gnuc_va_list in arg types in place of va_list.
964   # On 386BSD use __gnuc_va_list instead of _VA_LIST_. We're hoping the
965   # trailing parentheses and semicolon save all other systems from this.
966   # Define __va_list__ (something harmless and unused) instead of va_list.
967   # Don't claim to have defined va_list.
968   sed -e 's@ va_list @ __gnuc_va_list @' \
969       -e 's@ va_list)@ __gnuc_va_list)@' \
970       -e 's@ _VA_LIST_));@ __gnuc_va_list));@' \
971       -e 's@ va_list@ __va_list__@' \
972       -e 's@\*va_list@*__va_list__@' \
973       -e 's@_NEED___VA_LIST@_NEED___Va_LIST@' \
974       -e 's@VA_LIST@DUMMY_VA_LIST@' \
975       -e 's@_NEED___Va_LIST@_NEED___VA_LIST@' \
976     ${LIB}/$file >> ${LIB}/${file}.sed
977   
978   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
979   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
980     rm -f ${LIB}/$file
981   fi
982 fi
983
984 # Cancel out ansi_compat.h on Ultrix.  Replace it with empty file.
985 file=ansi_compat.h
986 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
987   if grep -s ULTRIX $file; then
988     echo "/* This file intentionally left blank.  */" > $LIB/$file
989   fi
990 fi
991
992 # parameter to atof not const on DECstation Ultrix V4.0.
993 # also get rid of bogus inline definitions in HP-UX 8.0
994 file=math.h
995 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
996   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
997   chmod +w ${LIB}/$file 2>/dev/null
998   chmod a+r ${LIB}/$file 2>/dev/null
999 fi
1000
1001 if [ -r ${LIB}/$file ]; then
1002   echo Fixing $file, non-const arg
1003   sed -e 's@atof( char \*__nptr );@atof( const char *__nptr );@' \
1004       -e 's@inline int abs(int d) { return (d>0)?d:-d; }@@' \
1005       -e 's@inline double abs(double d) { return fabs(d); }@@' \
1006     ${LIB}/$file > ${LIB}/${file}.sed
1007   rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
1008   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
1009     rm -f ${LIB}/$file
1010   fi
1011 fi
1012
1013 # In limits.h, put #ifndefs around things that are supposed to be defined
1014 # in float.h to avoid redefinition errors if float.h is included first.
1015 # On HP/UX this patch does not work, because on HP/UX limits.h uses
1016 # multi line comments and the inserted #endif winds up inside the
1017 # comment.  Fortunately, HP/UX already uses #ifndefs in limits.h; if
1018 # we find a #ifndef FLT_MIN we assume that all the required #ifndefs
1019 # are there, and we do not add them ourselves.
1020 file=limits.h
1021 if [ -r $file ] && [ ! -r ${LIB}/$file ]; then
1022   cp $file ${LIB}/$file >/dev/null 2>&1 || echo "Can't copy $file"
1023   chmod +w ${LIB}/$file 2>/dev/null
1024   chmod a+r ${LIB}/$file 2>/dev/null
1025 fi
1026
1027 if [ -r ${LIB}/$file ]; then
1028   if egrep 'ifndef[     ]+FLT_MIN' ${LIB}/$file >/dev/null; then
1029     true
1030   else
1031     echo Fixing $file
1032     sed -e '/[  ]FLT_MIN[       ]/i\
1033 #ifndef FLT_MIN'\
1034         -e '/[  ]FLT_MIN[       ]/a\
1035 #endif'\
1036         -e '/[  ]FLT_MAX[       ]/i\
1037 #ifndef FLT_MAX'\
1038         -e '/[  ]FLT_MAX[       ]/a\
1039 #endif'\
1040         -e '/[  ]FLT_DIG[       ]/i\
1041 #ifndef FLT_DIG'\
1042         -e '/[  ]FLT_DIG[       ]/a\
1043 #endif'\
1044         -e '/[  ]DBL_MIN[       ]/i\
1045 #ifndef DBL_MIN'\
1046         -e '/[  ]DBL_MIN[       ]/a\
1047 #endif'\
1048         -e '/[  ]DBL_MAX[       ]/i\
1049 #ifndef DBL_MAX'\
1050         -e '/[  ]DBL_MAX[       ]/a\
1051 #endif'\
1052         -e '/[  ]DBL_DIG[       ]/i\
1053 #ifndef DBL_DIG'\
1054         -e '/[  ]DBL_DIG[       ]/a\
1055 #endif'\
1056       ${LIB}/$file > ${LIB}/${file}.sed
1057     rm -f ${LIB}/$file; mv ${LIB}/${file}.sed ${LIB}/$file
1058   fi
1059   if cmp $file ${LIB}/$file >/dev/null 2>&1; then
1060     echo Deleting ${LIB}/$file\; no fixes were needed.
1061     rm -f ${LIB}/$file
1062   fi
1063 fi
1064
1065 # These two files on SunOS 4 are included by other files
1066 # in the same directory, using "...".  So we must make sure they exist
1067 # in the same directory as the other fixed files.
1068 if [ -r ${INPUT}/multimedia/audio_errno.h ]
1069 then
1070   ln -s ${INPUT}/multimedia/audio_errno.h ${LIB}/multimedia 2>/dev/null
1071 fi
1072 if [ -r ${INPUT}/multimedia/audio_hdr.h ]
1073 then
1074   ln -s ${INPUT}/multimedia/audio_hdr.h ${LIB}/multimedia 2>/dev/null
1075 fi
1076
1077 # Determine if we're on Interactive Unix 2.2 or later, in which case we
1078 # need to fix some additional files.  This is the same test for ISC that
1079 # Autoconf uses.
1080 if test -d /etc/conf/kconfig.d \
1081     && grep _POSIX_VERSION /usr/include/sys/unistd.h >/dev/null 2>&1; then
1082   echo "Fixing ISC __STDC__ goof in several files..."
1083   for name in stdio.h math.h ctype.h sys/limits.h sys/fcntl.h sys/dirent.h; do
1084     echo $name
1085     if test -r ${LIB}/$name; then
1086       file=${LIB}/$name
1087     else
1088       file=${INPUT}/$name
1089     fi
1090     # On Interactive 2.2, certain traditional Unix definitions
1091     # (notably getc and putc in stdio.h) are omitted if __STDC__ is
1092     # defined, not just if _POSIX_SOURCE is defined.  This makes it
1093     # impossible to compile any nontrivial program except with -posix.
1094     sed \
1095 's/!defined(__STDC__) && !defined(_POSIX_SOURCE)/!defined(_POSIX_SOURCE)/' \
1096             < $file > ${LIB}/$name.
1097     mv ${LIB}/$name. ${LIB}/$name
1098   done
1099   
1100   echo "Fixing ISC fmod declaration"
1101   # This one's already been fixed for other things.
1102   file=${LIB}/math.h
1103   sed 's/fmod(double)/fmod(double, double)/' <$file >$file.
1104   mv $file. $file
1105   
1106   echo "Fixing nested comments in ISC <sys/limits.h>"
1107   file=sys/limits.h
1108   sed '/CHILD_MAX/s,/\* Max, Max,' < ${INPUT}/$file >${LIB}/$file.
1109   sed '/OPEN_MAX/s,/\* Max, Max,' < ${LIB}/$file. >${LIB}/$file
1110 fi
1111
1112 echo 'Removing unneeded directories:'
1113 cd $LIB
1114 files=`find . -type d -print | sort -r`
1115 for file in $files; do
1116   rmdir $LIB/$file > /dev/null 2>&1
1117 done
1118
1119 if $LINKS; then
1120   echo 'Making internal symbolic non-directory links'
1121   cd ${INPUT}
1122   files=`find . -type l -print`
1123   for file in $files; do
1124     dest=`ls -ld $file | sed -n 's/.*-> //p'`
1125     if expr "$dest" : '[^/].*' > /dev/null; then    
1126       target=${LIB}/`echo file | sed "s|[^/]*\$|$dest|"`
1127       if [ -f $target ]; then
1128         ln -s $dest ${LIB}/$file >/dev/null 2>&1
1129       fi
1130     fi
1131   done
1132 fi
1133
1134 echo 'Cleaning up DONE files.'
1135 cd $LIB
1136 find . -name DONE -exec rm -f {} ';'
1137
1138 exit 0